module.exports = {
  env: {
    browser: false,
    commonjs: true,
    es2021: true,
  },
  extends: [
    'airbnb-base',
  ],
  parserOptions: {
    ecmaVersion: 12,
  },
  rules: {
    'object-property-newline': ['error', {
      allowAllPropertiesOnSameLine: true,
    }],
    'no-nested-ternary': 0,
    'consistent-return': 'off',
    'no-unused-expressions': 'off',
    'no-plusplus': 0,
    'no-continue': 0,
    radix: 0,
    'no-underscore-dangle': 0,
    'no-await-in-loop': 0,
    'no-use-before-define': 0,
    'no-param-reassign': 0,
    'max-len': ['error', 120, 2, {
      ignoreUrls: true,
      ignoreComments: true,
      ignoreRegExpLiterals: true,
      ignoreStrings: true,
      ignoreTemplateLiterals: true,
    }],
    'object-curly-newline': ['error', {
      ObjectPattern: { multiline: true },
      ImportDeclaration: 'never',
      ExportDeclaration: { multiline: true, minProperties: 3 },
    }],
    'lines-between-class-members': ['error', 'always', {
      exceptAfterSingleLine: true,
    }],
    'arrow-parens': ['error', 'as-needed', {
      requireForBlockBody: true,
    }],
    'function-paren-newline': ['error', { minItems: 10 }],
    // 'function-call-argument-newline': ['error', 'consistent'],
    'function-call-argument-newline': 'off',
  },
};
